<?php 
// Include-Datei "schuelerCbinaer.inc.php"

/*
 *******************************************************************************
 Aufbereiten Datei VORMERK
 (Schlerdatei fr die bungen A03, A07, A08, A09, A10, A11, A25 und A26)

        Satzlnge VORMERK = 80 + 9 = 89 (9 binre Nullen);
        keine int- oder float-Felder, kein Alignment.
        Daher bleibt die tatschliche Satzlnge = 89!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 89;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("efn" =>21,
                        "evn" =>11,
                        "eg"  => 1,      // char
                        "egd" => 9,
                        "erel"=> 3,
                        "est" => 4,
                        "ekl" => 6,
                        "eplz"=> 5,
                        "eort"=>13,
                        "estr"=>16);

    $offset = 0;
    $eber->efn  = substr($datensatz,$offset,$feldlaenge["efn"]-1);
    $offset += $feldlaenge["efn"];
    $eber->evn  = substr($datensatz,$offset,$feldlaenge["evn"]-1);
    $offset += $feldlaenge["evn"];
    $eber->eg   = substr($datensatz,$offset,$feldlaenge["eg"]);
    $offset += $feldlaenge["eg"];
    $eber->egd  = substr($datensatz,$offset,$feldlaenge["egd"]-1);
    $offset += $feldlaenge["egd"];
    $eber->erel = substr($datensatz,$offset,$feldlaenge["erel"]-1);
    $offset += $feldlaenge["erel"];
    $eber->est  = substr($datensatz,$offset,$feldlaenge["est"]-1);
    $offset += $feldlaenge["est"];
    $eber->ekl  = substr($datensatz,$offset,$feldlaenge["ekl"]-1);
    $offset += $feldlaenge["ekl"];
    $eber->eplz = substr($datensatz,$offset,$feldlaenge["eplz"]-1);
    $offset += $feldlaenge["eplz"];
    $eber->eort = substr($datensatz,$offset,$feldlaenge["eort"]-1);
    $offset += $feldlaenge["eort"];
    $eber->estr = substr($datensatz,$offset,$feldlaenge["estr"]-1);

    return $eber;
}
?>
