<?php 
// Include-Datei "kosten.inc.php"

/*
 *******************************************************************************
 Datei KOSTEN
 (bung A27)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 12;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ekst"  => 2,
                        "eka"   => 2,
                        "ebet"  => 8);     // float

    $offset = 0;
    $eber->ekst = substr($datensatz,$offset,$feldlaenge["ekst"]);
    $offset += $feldlaenge["ekst"];
    $eber->eka  = substr($datensatz,$offset,$feldlaenge["eka"]);
    $offset += $feldlaenge["eka"];
    $eber->ebet = substr($datensatz,$offset,$feldlaenge["ebet"]);

    $ok = settype($eber->ebet, "double");
    $eber->ebet = $eber->ebet / 100;             // 2 Nachkommastellen

    return $eber;
}
?>
