<?php 
// Include-Datei "schueler.inc.php"

/*
 *******************************************************************************
 Aufbereiten Datei VORMERK
 (Schlerdatei fr die bungen A03, A07, A08, A09, A10, A11, A25 und A26)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 80;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("efn" =>20,
                        "evn" =>10,
                        "eg"  => 1,      // char
                        "egd" => 8,
                        "erel"=> 2,
                        "est" => 3,
                        "ekl" => 5,
                        "eplz"=> 4,
                        "eort"=>12,
                        "estr"=>15);

    $offset = 0;
    $eber->efn  = substr($datensatz,$offset,$feldlaenge["efn"]);
    $offset += $feldlaenge["efn"];
    $eber->evn  = substr($datensatz,$offset,$feldlaenge["evn"]);
    $offset += $feldlaenge["evn"];
    $eber->eg   = substr($datensatz,$offset,$feldlaenge["eg"]);
    $offset += $feldlaenge["eg"];
    $eber->egd  = substr($datensatz,$offset,$feldlaenge["egd"]);
    $offset += $feldlaenge["egd"];
    $eber->erel = substr($datensatz,$offset,$feldlaenge["erel"]);
    $offset += $feldlaenge["erel"];
    $eber->est  = substr($datensatz,$offset,$feldlaenge["est"]);
    $offset += $feldlaenge["est"];
    $eber->ekl  = substr($datensatz,$offset,$feldlaenge["ekl"]);
    $offset += $feldlaenge["ekl"];
    $eber->eplz = substr($datensatz,$offset,$feldlaenge["eplz"]);
    $offset += $feldlaenge["eplz"];
    $eber->eort = substr($datensatz,$offset,$feldlaenge["eort"]);
    $offset += $feldlaenge["eort"];
    $eber->estr = substr($datensatz,$offset,$feldlaenge["estr"]);

    return $eber;
}

?>
