<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a07oo.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik objektorientiert" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme, objektorientiert" />

<title>A07 mit Klassen</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A07

 Schlerliste - Auswahl von Datenfeldern, unterschiedliche Ausgabezeilen.
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER MIT
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
 PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

require_once PFAD . "ooSkripte/Klassen/Schueler.class.php";
require_once PFAD . "ooSkripte/Klassen/LesenSchueler.class.php";
require_once PFAD . "ooSkripte/Klassen/AusgabeA07.class.php";

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

/* -------------------------------------------------------------------------- */

// Programmparameter:
$VG = "M";

$ldaten = new LesenSchueler();
$ausgabe = new AusgabeA07();

$ldaten->oeffnen($EINGABEDATEI);

$schueler = $ldaten->lesen();
while (!$ldaten->getEof())
{
    $ausgabe->uebernehmenDaten($schueler);
    $ausgabe->schreibenZeile($VG);

    $schueler = $ldaten->lesen();
}

$ldaten->schliessen();

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
