<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a17C.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A17 - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A17 (Version 1)

 Sortieren von Zahlenfolgen (einfacher Bubble-Sort).
 ---------------------------------------------------------------
 EINGABEDATEN: ZAHLENDATEI
       AUFBAU:
         1 - 10 (10) ... ZAHL X
        11 - 20 (10) ... ZAHL Y
        21 - 30 (10) ... ZAHL Z
 ---------------------------------------------------------------
 AUSGABEDATEN: BLOCKLISTE
       AUFBAU:
         3 ZEILEN FR JEDEN DATENSATZ:
             1. ZEILE MIT
                 X, Y, Z IN EINGABEREIHENFOLGE
                            SOWIE TEXT 'UNSORTIERT'
             2. ZEILE MIT
                 X, Y, Z IN SORTIERTER REIHENFOLGE
                            SOWIE TEXT 'SORTIERT'
             1 LEERZEILE
 
 PRO SEITE MAXIMAL 20 ZEILEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/zahlenCbinaer.inc.php";

$EINGABEDATEI = PFAD . "DateienCbinaer/zahlen.datC";

const LIM = 7;

const F_ABER = "%10d    %10d    %10d    %s<br />";

$text1 = "UNSORTIERT";
$text2 = "SORTIERT  ";
$bz = 99;

// Datenstruktur $eber
// Datenstruktur $aber

// int $bz

/* -------------------------------------------------------------------------- */
$ZAHLEN = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

$datensatz = fread($ZAHLEN, SATZLAENGE);
while (!feof($ZAHLEN))
{
    $eber = aufbereitenDatensatz($datensatz);
    
    $aber->ax = $eber->ex;
    $aber->ay = $eber->ey;
    $aber->az = $eber->ez;
    $aber->atext = $text1;
    if ($bz >= LIM)
    {
        printf(NEUESEITE);
        $bz = 0;
    }
    printf(F_ABER, $aber->ax, $aber->ay, $aber->az, $aber->atext);
    upsort($eber);
    $aber->ax = $eber->ex;
    $aber->ay = $eber->ey;
    $aber->az = $eber->ez;
    $aber->atext = $text2;
    printf(F_ABER, $aber->ax, $aber->ay, $aber->az, $aber->atext);
    printf(LEERZEILE);
    $bz++;
    $datensatz = fread($ZAHLEN, SATZLAENGE);
}

fclose($ZAHLEN);
/* -------------------------------------------------------------------------- */

function upsort(&$eber)
{
// char $schtausch

    define("JA",   'J');
    define("NEIN", 'N');

    $schtausch = JA;
    while ($schtausch == JA)
    {
        $schtausch = NEIN;
        if ($eber->ex > $eber->ey)
        {
            uptauschxy($eber);
            $schtausch = JA;
        }
        if ($eber->ey > $eber->ez)
        {
            uptauschyz($eber);
            $schtausch = JA;
        }
    }
} // -------------------------------------------- Ende upsort

function uptauschxy(&$eber)
{
// int $hilf

    $hilf = $eber->ex;
    $eber->ex = $eber->ey;
    $eber->ey = $hilf;
} // -------------------------------------------- Ende uptauschxy

function uptauschyz(&$eber)
{
// int $hilf

    $hilf = $eber->ey;
    $eber->ey = $eber->ez;
    $eber->ez = $hilf;
} // -------------------------------------------- Ende uptauschyz

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
