<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a09.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A09</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A09

 Eingabe von Parametern ber Vorlaufsatz.
 Parametrisieren der bung A08 (Klassenliste).
 ---------------------------------------------------------------
 EINGABEDATEN: VORLAUFSATZ
       AUFBAU:
         1 -  7 ( 7) ... KONSTANTE KENNUNG 'KLASSE:'
           8    ( 1) ... LEER
         9 - 13 ( 5) ... AUSZUWHLENDE KLASSE
 
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE FR EINE EINZUGEBENDE KLASSE
       AUFBAU:
         1 HAUPTBERSCHRIFT MIT DER AUSGEWHLTEN KLASSE
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER DER AUSGEWHLTEN KLASSE.
             JEDE ZEILE MIT
                LAUFENDER NUMMER
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
 PRO SEITE MAXIMAL 20 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/schueler.inc.php";

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

const ZMAX = 20;

const F_ABUE1 = "<strong>                     S C H &Uuml; L E R L I S T E    F&Uuml;R DIE KLASSE  %s</strong><br />";
const ABUE2   = "<strong>                LFD.NUMMER  FAMILIENNAME         VORNAME     GEBURTSDATUM</strong><br />";
const F_AB    = "                    %02d      %s %s    %s  <br />";

const ABF1 = "VORLAUFSATZ FEHLT <br />";
const ABF2 = "VORLAUFSATZ FALSCH<br />";

/*
 Programmparameter der Einfachheit halber als Konstante definieren 
 (damit knnen diese Konstante direkt in Funktionen verwendet werden):
*/
const VG   = 'M';
const VVTX = "KLASSE:";

// Datenstruktur $vb
// Datenstruktur $eb
// Datenstruktur $ab
// Datenstruktur $abue1

// int $zz
// int $rlnr

/* -------------------------------------------------------------------------- */
$vb->vtx = $_POST["formVtx"];
$vb->vkl = $_POST["formVkl"];

if ($vb->vtx == "" || $vb->vtx == " " || $vb->vkl == "" || $vb->vkl == " ")
    upfel1();
else
    if ($vb->vtx == VVTX)
    {
        $abue1->akl = $vb->vkl;
        uproga8($EINGABEDATEI, $vb, $abue1);
    }
    else
        upfel2();

printf(NEUESEITE);
/* -------------------------------------------------------------------------- */
function uproga8($datei, $vb, $abue1)
{
    $SCHULE = fopen($datei, "rb") 
                 or die("<p>Die Datei <b>$datei</b> existiert nicht.</p>");

    upstart($zz, $rlnr);
    $datensatz = fread($SCHULE, SATZLAENGE);
    while (!feof($SCHULE))
    {
        $eb = aufbereitenDatensatz($datensatz);
        if ($eb->ekl == $vb->vkl)
            upva($abue1, $eb, $rlnr, $zz);
        $datensatz = fread($SCHULE, SATZLAENGE);
    }

    fclose($SCHULE);
} // -------------------------------------------- Ende uproga8

function upstart(&$zz, &$rlnr)
{
    $zz = ZMAX;
    $rlnr = 0;
} // -------------------------------------------- Ende upstart

function upva($abue1, $eb, &$rlnr, &$zz)
{
    $ab = upaber($eb, $rlnr);
    if ($zz >= ZMAX)
        upueber($abue1, $zz);
    printf(F_AB, $ab->alnr, $ab->afn, $ab->avn, $ab->agd);
    $zz++;
} // -------------------------------------------- Ende upva

function upaber($eb, &$rlnr)
{
    $rlnr++;
    $ab->alnr = $rlnr;
    $ab->afn = $eb->efn;
    $ab->avn = $eb->evn;
    if ($eb->eg == VG)
        $ab->agd = $eb->egd;
    else
        $ab->agd = str_pad("", strlen($eb->egd));
        
    return $ab;
} // -------------------------------------------- Ende upaber

function upueber($abue1, &$zz)
{
    printf(NEUESEITE);
    printf(F_ABUE1, $abue1->akl);
    printf(LEERZEILE);
    printf(ABUE2);
    printf(LEERZEILE);
    $zz = 4;
} // -------------------------------------------- Ende upueber

function upfel1()
{
    printf(NEUESEITE);
    printf(ABF1);
} // -------------------------------------------- Ende upfel1

function upfel2()
{
    printf(NEUESEITE);
    printf(ABF2);
} // -------------------------------------------- Ende upfel2

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
