<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a25.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A25</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A25

 Schlerzahlen - einfacher Gruppenwechsel.
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 
 DIE DATENSTZE SIND AUFSTEIGEND SORTIERT NACH DER KLASSE.
 ---------------------------------------------------------------
 AUSGABEDATEN: KLASSEZAHLEN
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE FR JEDE KLASSE MIT
             KLASSE
             ANZAHL SCHLER DER KLASSE
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             GESAMTANZAHL ALLER SCHLER
 
 PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE),
      AUSGENOMMEN DIE LETZTE SEITE.
 DIE SUMMENZEILE SOLL NICHT UNMITTELBAR AUF DIE
 BERSCHRIFT FOLGEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/schueler.inc.php";

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

const HIGH = "\xff\xff\xff\xff\xff";

const ZMAX = 20;

const ABUE  = "<strong>                            KLASSE          SCH&Uuml;LERZAHL</strong><br />";
const F_AB  = "                             %s               %2d <br />";
const F_ABS = "                 GESAMTANZAHL ALLER SCHUELER:  %4d <br />";
const F_ABF = "SORTIERFOLGEFEHLER BEI %s <br />";

// Datenstruktur $eb
// Datenstruktur $ab
// Datenstruktur $abs
// Datenstruktur $abf

// string(5) $vkl
// int       $sum
// int       $gsum
// int       $zz

/* -------------------------------------------------------------------------- */
$SCHULE = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

uprogvor($gsum, $zz);
$eb = uplesen($SCHULE);
while ($eb->ekl != HIGH)
{
    upgrvor($eb, $ab, $vkl, $sum);
    while ($eb->ekl == $vkl)
    {
        upeinzel($sum);
        $eb = uplesen($SCHULE);
    }
    upgrnach($ab, $sum, $gsum, $zz);
    upsort($eb, $vkl, $zz);
}
uprognach($gsum);

fclose($SCHULE);
/* -------------------------------------------------------------------------- */

function uplesen(&$datei)
{
// Datenstruktur $eber

    $datensatz = fread($datei, SATZLAENGE);
    if (feof($datei))
        $eber->ekl = HIGH;
    else
        $eber = aufbereitenDatensatz($datensatz);
    return $eber;
} // -------------------------------------------- Ende uplesen

function uprogvor(&$gsum, &$zz)
{
    $zz = ZMAX;
    $gsum = 0;
} // -------------------------------------------- Ende uprogvor

function upgrvor($eb, &$ab, &$vkl, &$sum)
{
    $sum = 0;
    $ab->akl = $eb->ekl;
    $vkl = $eb->ekl;
} // -------------------------------------------- Ende upgrvor

function upeinzel(&$sum)
{
    $sum++;
} // -------------------------------------------- Ende upeinzel

function upgrnach($ab, $sum, &$gsum, &$zz)
{
    $ab->asum = $sum;
    upueb($zz);
    printf(F_AB, $ab->akl, $ab->asum);
    $zz++;
    $gsum = $gsum + $sum;
} // -------------------------------------------- Ende upgrnach

function upsort($eb, $vkl, &$zz)
{
    if ($eb->ekl < $vkl)
    {
        $abf->afkl = $eb->ekl;
        upueb($zz);
        printf(F_ABF, $abf->afkl);
        $zz++;
    }
} // -------------------------------------------- Ende upsort

function uprognach($gsum)
{
    printf(LEERZEILE);
    $abs->agsum = $gsum;
    printf(F_ABS, $abs->agsum);
} // -------------------------------------------- Ende uprognach

function upueb(&$zz)
{
    if ($zz >= ZMAX)
    {
        printf(NEUESEITE);
        printf(ABUE);
        printf(LEERZEILE);
        $zz = 2;
    }
} // -------------------------------------------- Ende upueb

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
