<?php 
// Klassen-Datei AusgabeA07.class.php

include_once PFAD . "ausgabesteuerungskonstante.inc.php";

/*
 *******************************************************************************
 bung A07 - Ausgabe

 Deklaration des Ausgabebereichs
 Definition des Formats fr den Ausgabebereich
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/
class AusgabeA07
{
    // -------------------------------------------------------------------------
    // Klassenvariable
    // -------------------------------------------------------------------------

    const ZZG  = 22;

    const ABU  = "<strong>      FAMILIENNAME             VORNAME        GEBURTSDATUM</strong><br />";
    const F_AB = "      %s     %s       %s<br />";

    // -------------------------------------------------------------------------
    // Instanzvariable
    // -------------------------------------------------------------------------

    private $fn;      // string(20)
    private $vn;      // string(10)
    private $g;       // char
    private $gd;      // string( 8)

    private $zz;

    // -------------------------------------------------------------------------
    // Konstruktoren
    // -------------------------------------------------------------------------

    public function __construct()
    {
        $this->zz = self::ZZG;
    }

    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    public function uebernehmenDaten($schueler)
    {
        $this->fn = $schueler->getFn();
        $this->vn = $schueler->getVn();
        $this->gd = $schueler->getGd();
        $this->g  = $schueler->getG();
    }

    // -------------------------------------------------------------------------

    public function schreibenZeile($vg)
    {
        if ($this->g != $vg)
            $this->gd = str_pad("", strlen($this->gd));
        if ($this->zz >= self::ZZG)
            $this->ueb($zz);
        printf(self::F_AB, $this->fn, $this->vn, $this->gd);
        $this->zz = $this->zz + 1;
    }

    // -------------------------------------------------------------------------

    private function ueb()
    {
        printf(NEUESEITE);
        printf(self::ABU);
        printf(LEERZEILE);
        $this->zz = 2;
    }
}
?>
