<?php 
// Include-Datei "kloeschCbinaer.inc.php"

/*
 *******************************************************************************
 Datei KLOESCH
 (bung A40)

        Satzlnge KLOESCH = 4 + 1 = 5 (1 binre Null);
        keine int- oder float-Felder, kein Alignment.
        Daher bleibt die tatschliche Satzlnge = 5!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEKLOESCH = 5;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzKloesch($datensatz)
{
    $feldlaenge = array("knr"=>5);

    $offset = 0;
    $eber->knr = substr($datensatz,$offset,$feldlaenge["knr"]-1);

    return $eber;
}
?>
