<?php 
// Include-Datei "kaender.inc.php"

/*
 *******************************************************************************
 Datei KAENDER
 (bung A39)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEKAENDER = 11;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzKaender($datensatz)
{
    $feldlaenge = array("knr"   => 4,
                        "kpreis"=> 7);     // float

    $offset = 0;
    $eber->knr    = substr($datensatz,$offset,$feldlaenge["knr"]);
    $offset += $feldlaenge["knr"];
    $eber->kpreis = substr($datensatz,$offset,$feldlaenge["kpreis"]);

    $ok = settype($eber->kpreis, "double");
    $eber->kpreis = $eber->kpreis / 100;         // 2 Nachkommastellen

    return $eber;
}
?>
