<?php 
// Include-Datei "kloesch.inc.php"

/*
 *******************************************************************************
 Datei KLOESCH
 (bung A40)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEKLOESCH = 4;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzKloesch($datensatz)
{
    $feldlaenge = array("knr"=>4);

    $offset = 0;
    $eber->knr = substr($datensatz,$offset,$feldlaenge["knr"]);

    return $eber;
}
?>
