<?php 
// Include-Datei "zahlen.inc.php"

/*
 *******************************************************************************
 Datei ZAHLEN
 (bung A17)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 30;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ex"=>10,      // int
                        "ey"=>10,      // int
                        "ez"=>10);     // int

    $offset = 0;
    $eber->ex = substr($datensatz,$offset,$feldlaenge["ex"]);
    $offset += $feldlaenge["ex"];
    $eber->ey = substr($datensatz,$offset,$feldlaenge["ey"]);
    $offset += $feldlaenge["ey"];
    $eber->ez = substr($datensatz,$offset,$feldlaenge["ez"]);

    $ok = settype($eber->ex, "integer");
    $ok = settype($eber->ey, "integer");
    $ok = settype($eber->ez, "integer");

    return $eber;
}
?>
