<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a03oo.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik objektorientiert" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme, objektorientiert" />

<title>A03 mit Klassen</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A03

 Schlerliste - aufbereiten Datenfelder, Seitenvorschub.
 Verwendung von 'include'
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE
       AUFBAU:
         1 ZEILE PRO SCHLER MIT
             FAMILIENNAME
             VORNAME
             GEBURTSDATUM

 PRO SEITE MAXIMAL 22 ZEILEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

/*
 Die Konstante fr den relativen Pfad zum privaten Projektverzeichnis befindet 
 sich im aktuellen (ffentlichen) Verzeichnis in einer Include-Datei und wird 
 durch den nachfolgenden 'include'-Befehl in das Programm eingefgt:
*/
include_once "projektpfad.inc.php";

require_once PFAD . "ooSkripte/Klassen/Schueler.class.php";
require_once PFAD . "ooSkripte/Klassen/LesenSchueler.class.php";
require_once PFAD . "ooSkripte/Klassen/AusgabeA03.class.php";

/*
 Die tatschlich verwendete Datei wird im 'fopen'-Befehl festgelegt.
 Um den Dateinamen und/oder den Pfad ndern zu knnnen (z.B. durch eine 
 Benutzereingabe), wird die folgende Variable 'EINGABEDATEI' definiert (der 
 Einfachheit halber wird der Dateiname mit dem Pfad jedoch fix vorgegeben):
*/
$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
//$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

/* -------------------------------------------------------------------------- */
$ldaten = new LesenSchueler();
$ausgabe = new AusgabeA03();

$ldaten->oeffnen($EINGABEDATEI);

$schueler = $ldaten->lesen();
while (!$ldaten->getEof())
{
    $ausgabe->uebernehmenDaten($schueler);
    $ausgabe->schreibenZeile();

    $schueler = $ldaten->lesen();
}

$ldaten->schliessen();

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
