<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a01define.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A01 mit 'define'</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A01

 Einfhrungsbeispiel - Leseschleife

 Definition von Konstanten ('define')
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 80 ... SCHLERDATEN
                    (WIE NAME, GEBURTSDATUM, ADRESSE USW.)
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE
       AUFBAU:   1 ZEILE PRO SCHLER MIT ALLEN SCHLERDATEN
                               (D.H. MIT DEM DATENSATZINHALT)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

/*
 Konstante fr den relativen Pfad zum privaten Projektverzeichnis
 (im privaten Projektverzeichnis befinden sich die Daten-Dateien)
*/
define("PFAD", "../../../logikBuch/");

/*
 Konstante fr die Satzlnge der Datei VORMERK
 (bzw. der Dateien "vormerk.dat" und "schueler.dat")
*/
define("SATZLAENGE", 80);

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

/* --- Datenfeld-Definitionen ------ */
// string $eb
// string $ab
/* --------------------------------- */

$VORMERK = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

/* --- Struktogramm ---------------- */
$eb = fread($VORMERK, SATZLAENGE);
while (!feof($VORMERK))
{
    $ab = $eb;
    printf("%s<br />",$ab);
    $eb = fread($VORMERK, SATZLAENGE);
}
/* --------------------------------- */

fclose($VORMERK);

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
