<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a05.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A05</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A05

 Vertreterliste - Auswahl von Datenstzen,
                  Verwendung von Unterprogrammen bzw. Funktionen.
 ---------------------------------------------------------------
 EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  6 ( 6) ... VERTRETERNUMMER
         7 - 35 (29) ... VERTRETERNAME
        36 - 46 (11) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 ---------------------------------------------------------------
 AUSGABEDATEN: VERTRETERUMSATZLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE FR JENE VERTRETER, DEREN UMSATZ GRSSER
            ALS 300.000,-- EURO IST.
            JEDE ZEILE MIT
               VERTRETERNAME
               VERTRETERUMSATZ
 
 PRO SEITE MAXIMAL 20 ZEILEN.
 DIE BERSCHRIFT SOLL NUR AM VERARBEITUNGSBEGINN GESCHRIEBEN
 WERDEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/vertret.inc.php";

$EINGABEDATEI = PFAD . "DateienASCII/vertreter.dat";

const ZZG = 20;

const OUTKOPF = "<strong>VERTRETER MIT UMS&Auml;TZEN &Uuml;BER EUR 300.000,-- </strong><br />";
const F_OUT   = "%s % 13.2f<br />";

$VGL = 300000.0;

// Datenstruktur $ein
// Datenstruktur $out

// int $zz

/* -------------------------------------------------------------------------- */
$VERTRET = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

ueber($zz);
$datensatz = fread($VERTRET, SATZLAENGE);
while (!feof($VERTRET))
{
    $ein = aufbereitenDatensatz($datensatz);
    if ($ein->eums >= $VGL)
        ausgabe($ein, $out, $zz);
    $datensatz = fread($VERTRET, SATZLAENGE);
}

fclose($VERTRET);
/* -------------------------------------------------------------------------- */

/*
 Beginnt eine neue Seite und schreibt eine berschrift.
 
 @param   int   $zz  Ausgangsparameter:
                     Zeilenzhler
 @return  void
*/
function ueber(&$zz)
{
    printf(NEUESEITE);
    printf(OUTKOPF);
    printf(LEERZEILE);
    $zz = 2;
} // -------------------------------------------- Ende ueber

/*
 1 Ausgabezeile aufbereiten und schreiben 
 (gegebenenfalls auf einer neuen Seite).
 
 @param   struct  $ein  Eingabebereich
 @param   struct  $out  Ausgangsparameter:
                        Ausgabebereich
 @param   int     $zz   Durchgangsparameter:
                        Zeilenzhler

 @return  void
*/
function ausgabe($ein, &$out, &$zz)
{
    $out->anam = $ein->enam;
    $out->aums = $ein->eums;
    if ($zz >= ZZG)
    {
        printf(NEUESEITE);
        $zz = 0;
    }
    printf(F_OUT, $out->anam, $out->aums);
    $zz = $zz + 1;
} // -------------------------------------------- Ende ausgabe

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
