<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a07zusDefineParameter".php -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A07zusatz</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A07

 Schlerliste - Auswahl von Datenfeldern, unterschiedliche Ausgabezeilen.
 Programmparameter der Einfachheit halber als Konstante ('define')
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER MIT
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
 PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/schueler.inc.php";

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

const ZZG = 22;

const ABU  = "<strong>      FAMILIENNAME             VORNAME        GEBURTSDATUM</strong><br />";
const F_AB = "      %s     %s       %s<br />";

/*
 Programmparameter der Einfachheit halber als Konstante definieren 
 (damit kann diese Konstante direkt in Funktionen verwendet werden):
*/
const VG = 'M';

// Datenstruktur $eb
// Datenstruktur $ab

// int $zz

/* -------------------------------------------------------------------------- */
$VORMERK = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

upanf($zz);
$datensatz = fread($VORMERK, SATZLAENGE);
while (!feof($VORMERK))
{
    $eb = aufbereitenDatensatz($datensatz);
    upva($eb, $ab);
    upausgabe($ab, $zz);
    $datensatz = fread($VORMERK, SATZLAENGE);
}

fclose($VORMERK);
/* -------------------------------------------------------------------------- */

function upanf(&$zz)
{
    $zz = ZZG;
} // -------------------------------------------- Ende upanf

function upva($eb, &$ab)
{
    $ab->afn = $eb->efn;
    $ab->avn = $eb->evn;
    if ($eb->eg == VG)
        $ab->agd = $eb->egd;
    else
        $ab->agd = str_pad("", strlen($eb->egd));
} // -------------------------------------------- Ende upva

function upausgabe($ab, &$zz)
{
    if ($zz >= ZZG)
        upueb($zz);
    printf(F_AB, $ab->afn, $ab->avn, $ab->agd);
    $zz = $zz + 1;
} // -------------------------------------------- Ende upausgabe

function upueb(&$zz)
{
    printf(NEUESEITE);
    printf(ABU);
    printf(LEERZEILE);
    $zz = 2;
} // -------------------------------------------- Ende upueb

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
